<?php
// Author: Kevin K.M. Chiu
// Copyright 2000, Cobalt Networks.  All rights reserved.
// $Id: apache.php,v 1.12 2000/09/13 19:36:04 will Exp $

include("ArrayPacker.php");
include("ServerScriptHelper.php");

$serverScriptHelper = new ServerScriptHelper();
$cceClient = $serverScriptHelper->getCceClient();
$factory = $serverScriptHelper->getHtmlComponentFactory("base-apache", "/base/apache/apacheHandler.php");

// get web
$web = $cceClient->getObject("System", array(), "Web");

// get frontpage
$frontpage = $cceClient->getObject("System", array(), "Frontpage");

// get all user names
$users = $cceClient->getObjects("User");
$userNames = array();
for($i = 0; $i < count($users); $i++)
  $userNames[] = $users[$i]["name"];
$userNamesString = arrayToString($userNames);

$page = $factory->getPage();

$block = $factory->getPagedBlock("apacheSettings");

// make frontpage field
// password only needed to enable frontpage
if(!$frontpage["enabled"]) {
  $enable = $factory->getOption("frontpageEnabled", $frontpage["enabled"]);
  $enable->addFormField(
    $factory->getPassword("passwordWebmasterField"),
    $factory->getLabel("passwordWebmasterField")
  );
  $frontpageEnabled = $factory->getMultiChoice("frontpageField");
  $frontpageEnabled->addOption($enable);
}
else
  $frontpageEnabled = $factory->getBoolean("frontpageField", $frontpage["enabled"]);
$block->addFormField(
  $frontpageEnabled,
  $factory->getLabel("frontpageField")
);

// make cgi field
$access = $web["cgiAccess"];
$users = $web["cgiUsers"];
$cgiSubset = $factory->getOption("cgiSubset", $access == "subset" && $users != "");
$cgiSubset->addFormField(
  $factory->getSetSelector("cgiUsersField", $users, $userNamesString, "cgiUsersAllowed", "cgiUsersDisallowed"),
  $factory->getLabel("cgiUsersField")
);
$cgiAccess = $factory->getMultiChoice("cgiAccessField");
$cgiAccess->addOption($factory->getOption("cgiNone", $access == "subset" && $users == ""));
$cgiAccess->addOption($factory->getOption("cgiAll", $access == "all"));
$cgiAccess->addOption($cgiSubset);
$block->addFormField(
  $cgiAccess,
  $factory->getLabel("cgiAccessField")
);

$block->addButton($factory->getSaveButton($page->getSubmitAction()));

$serverScriptHelper->destructor();
?>
<?php print($page->toHeaderHtml()); ?>

<?php print($block->toHtml()); ?>

<?php print($page->toFooterHtml()); ?>
